/* deal with the db server's side of the file accesses, which are the
   ones which actually hit the raw files, and stuff. */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <signal.h>
#include <sys/types.h>

#include "db.h"

extern BBS_Config *config;
extern struct ll_inc *inc_list;

int db_inc_send(BBS_Inc *msg) {

     struct ll_inc *prev;
     static struct ll_inc *new;
     BBS_Node destnode;

#ifdef DEBUG
     printf("from %d to %d, %s - %s\n", msg->orig_node, msg->dest_node, 
	    msg->type, msg->msg);
#endif

     if(db_node_read(&destnode, msg->dest_node) == -1)
	  return FAILURE;
     

     new = (struct ll_inc *)malloc(sizeof(struct ll_inc));
     memcpy(&(new->data), msg, sizeof(BBS_Inc));
     new->next = NULL;

     /* nothing else in the list, just put this there */
     if(inc_list == NULL) 
	  inc_list = new;
     else {
	  prev = inc_list;
	  while (prev->next != NULL) 
	       prev = prev->next;
	  prev->next = new;
     }  
     
     /* alright, it's in the list, so try to contact the reciever for
	a pickup. */
     
     if(kill(destnode.pid, SIGUSR2) != 0) {
	  perror("kill dest_node");
	  db_node_clear(msg->dest_node);
	  return FAILURE;
     }

     return SUCCESS;
     
}

int db_inc_pickup(BBS_Inc *msg, int node) {

     struct ll_inc *cur;
     struct ll_inc *prev = NULL;

     cur = inc_list;

     while((cur != NULL) && (cur->data.dest_node != node)) {
	  prev = cur;
	  cur = cur->next;
     }

     /* never found the message. */
     if(cur == NULL)
	  return FAILURE;
     
     /* alright, it should be in cur. */
     
     /* at the beginning? */
     if(prev == NULL) 
	  inc_list = cur->next;
     else
	  prev->next = cur->next;
     
     memcpy(msg, &(cur->data), sizeof(BBS_Inc));
     free(cur);
	  
     return SUCCESS;

}
