/* do the message mangling, on the database side.  oh, dear. */

/* I think I added proper path handling for the whole file. -Joe */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <dirent.h>
#include <errno.h>
#include <sys/stat.h>
#include <sys/mman.h>

#include "db.h"

extern BBS_Config *config;
extern struct ll_areas *area_config;
extern struct ll_nets *net_config;

/* used in here... */
int do_num_sort (struct dirent **one, struct dirent **two);
int read_one_net_config(MSG_Net *net, char *filename);
int dir_match(struct dirent *entry);
int net_match(struct dirent *entry);
MSG_Area *area_by_name(char *name);
DBM *open_pointers(void);

/* my lord, this fucker is hideous.  some cleaning attempted during
   rewrite. */

void read_msg_config(void) {

     FILE *mconfig;
     char *path;
     int groupsfd;
     char filename[80];
     static struct ll_areas *cur;
     struct ll_areas *prev;
     char *field;
     char *value;
     char *fullpath;
     char *fullline;
     char *freeline;
     FILE *grlist;

     path = (char *)alloca(80);
     field = (char *)alloca(80);
     freeline = field;

     area_config = (struct ll_areas *)calloc(1,sizeof(struct ll_areas));
     cur = area_config;
     
     prev = NULL;

     fullpath = (char *)alloca(sizeof(config->base_dir)+16);
     strcpy(fullpath,config->base_dir);
     strcat(fullpath,"/messages/groups");

     if((grlist = fopen(fullpath, "r")) == NULL) {
	  printf("Couldn't open groups file %s\n", fullpath);
	  exit(127);
     }

     while(fgets(path, 80, grlist) != NULL) {
	  if((path[0] < 33) || (path[0] > 126)) 
	       continue;
	  /* clean off trailing newline from read in pathname. */
	  path[strlen(path)-1] = 0;

	  sprintf(filename,"%s/messages/%s/config",config->base_dir,path);
          if((mconfig = fopen(filename,"r")) == NULL) {
               printf("couldn't open config file for %s, skipping.\n",path);
	       continue;
	  }

	  strncpy(cur->data.path, path, 36);

	  while (fgets(field, 80, mconfig) != NULL) {
	       fullline = field;

	       field = strsep(&fullline, " ");
	       value = strsep(&fullline, "\n");
	       if(!strncmp(field, "name", 4)) 
		    strncpy(cur->data.area_name, value,
			    sizeof(cur->data.area_name));
	       else if(!strncmp(field, "network", 7))
		    cur->data.network_num = atoi(value);
	       else if(!strncmp(field, "desc", 4))
		    strncpy(cur->data.desc, value,
			    sizeof(cur->data.desc));
	       else if(!strncmp(field, "expire", 6))
		    cur->data.expire = atoi(value);
	       else if(!strncmp(field, "real", 4))
		    cur->data.real = atoi(value);
	       else if(!strncmp(field, "access", 6))
		    cur->data.access = atoi(value);
	       else if(!strncmp(field, "private", 6))
		    cur->data.private = atoi(value);
	       else {
		    printf("Unknown msg config file directive: %s\n",
			    field);
		    continue; }

	  }
	  scan_msg_area(&(cur->data)); 
	  
	  prev = cur;
	  cur->next = (struct ll_areas *)calloc(1, sizeof(struct
							  ll_areas));
	  cur = cur->next;
	  fclose(mconfig);
     }

#ifdef DEBUG
     printf("finished groups\n");
#endif     

     if(prev != NULL) {
	  free(cur);
	  prev->next = NULL;
     }

     fclose(grlist);

     return;

}

int read_one_net_config(MSG_Net *net, char *filename) {
     
     FILE *conf;
     char *field;
     char *value;
     char fullname[80];
     char *fullline;

     sprintf(fullname, "%s/messages/%s", config->base_dir, filename);

     if((conf = fopen(fullname, "r")) == NULL) {
	  printf("Couldn't open network config %s\n", fullname);
	  exit(127);
     }

     value = (char *)alloca(200);
     fullline = value;

     while (fgets(value, 80, conf) != NULL) {
	  if((value[0] < 33) || (value[0] > 126))
               continue;
	  value[strlen(value)-1] = 0; /* kill trailing
					 newline. */

	  field = strsep(&value, " ");
	  
	  if(!strcmp(field,"name"))
	       strcpy(net->name, value);
	  else if(!strncmp(field, "id",2)) {
	       net->netid = atoi(value);
#ifdef DEBUG
	       printf("id should be %d\n", net->netid);
#endif
	  }
	  else if(!strcmp(field, "outgoing"))
	       strcpy(net->outgoing, value);
	  else if(!strcmp(field, "host"))
	       strcpy(net->host, value);
	  else if(!strcmp(field, "desc"))
	       strncpy(net->desc, value, sizeof(net->desc));
	  else if(!strcmp(field, "addr")) {
	       strncpy(net->addr_str, value, sizeof(net->addr_str));
	       sscanf(value, "%d:%d/%d.%d", &net->zone, &net->net,
		      &net->node, &net->point);
	  }
	  else if(!strcmp(field, "netmail")) 
	       strncpy(net->netmail, value, sizeof(net->netmail)); 
	  else {
	       printf("Unknown network config directive %s\n",field);
	       exit(127);
	  }


     }

     fclose(conf);

#ifdef DEBUG
     printf("%s: %d:%d/%d.%d\n", net->name, net->zone, net->net,
	    net->node, net->point);
#endif
     
     return 0;

}

void read_net_config(void) {

     struct dirent **cfgs;
     struct ll_nets *cur;
     struct ll_nets *prev;
     int cfgns;
     char path[80];
     int x, i = 0;
     x = 0;

     sprintf(path, "%s/messages", config->base_dir);

     cfgns = scandir(path, &cfgs, net_match, NULL);
     if(cfgns == 0) {
	  printf("No message groups defined. Fatal.\n");
	  exit(127);
     }
     
#ifdef DEBUG
     printf("%d nets evident.\n", cfgns);
#endif

     net_config = (struct ll_nets *)malloc(sizeof(struct ll_nets));
     read_one_net_config(&(net_config->data), cfgs[x]->d_name);
     cur = net_config;
     x = 1;

     if(cfgns == 1) {
	  cur->next = NULL;
	  return;
     }
     
     do {
	  prev = cur;
	  cur = (struct ll_nets *)malloc(sizeof(struct ll_nets));
	  read_one_net_config(&(cur->data), cfgs[x]->d_name);
	  prev->next = cur;
	  x++;
     } while (x < cfgns);
     
     cur->next = NULL;

#ifdef DEBUG
     printf("%d message nets scanned.\n", x);
#endif

     while(i < cfgns) {
	  free(cfgs[i]);
	  i++;
     }

     free(cfgs);

     return;
}
	  

int do_num_sort (struct dirent **one, struct dirent **two) {

     int first;
     int second;
     int ret;
     char *strone;
     char *strtwo;
     
     strone = one[0]->d_name;
     strtwo = two[0]->d_name;

     first = atoi(strsep(&strone, "."));
     second = atoi(strsep(&strtwo, "."));

     if(first == second) 
	  ret = 0;
     if(first < second)
	  ret = -1;
     if(first > second)
	  ret = 1;

     return ret;

}

/* scan_msg_area assumes it's caller has mutexed the message areas. */
  
void scan_msg_area(MSG_Area *area) {

     struct dirent **names;
     int msgs;
     int i = 0;
     char *path;

     path = (char *)alloca(80);

     sprintf(path, "%s/messages/%s", config->base_dir, area->path);
 
     msgs = scandir(path, &names, dir_match, do_num_sort);
     
#ifdef DEBUG
     printf("%s: %d messages.\n",area->area_name, msgs);
#endif
     
     if(msgs == 0) {
	  area->first = 0;
	  area->last = 0;
	  return;
     }
     
     area->first = atoi(strtok(names[0]->d_name, "."));
     area->last = atoi(strtok(names[msgs-1]->d_name,"."));
#ifdef DEBUG
     printf("first: %d, last: %d\n",area->first, area->last);
#endif

     /* free each element of the dirent. */
     while(i < msgs) {
	  free(names[i]);
	  i++;
     }

     free(names);
     
     return;

}

int dir_match(struct dirent *entry) {
      

     if(strstr(entry->d_name, ".msg") != NULL) 
	  return 1;
     else
	  return 0;

}

int net_match(struct dirent *entry) {

     if(strstr(entry->d_name, ".net") != NULL) 
	  return 1;
     else
	  return 0;

}

int db_msg_write(char *text, int size, MSG_Ref *where) {

     int msg_fd;
     char path[80];
     char buffer[80];
     MSG_Area *area;

     if((area = area_by_name(where->name)) == NULL) 
	  return FAILURE;

     sprintf(path, "%s/messages/%s/%d.msg",config->base_dir,area->path,area->last+1);
     
     /* the packer inserts our control lines, so we don't have to do
	it here. */

     msg_fd = open(path, O_WRONLY | O_CREAT | O_EXCL, S_IRUSR |
		   S_IWUSR | S_IRGRP | S_IROTH);

     if(msg_fd == -1) {
	  perror("msg_write");
	  fprintf(stderr, "%s\n", path);
	  return FAILURE; 
     }
     
     write(msg_fd, text, size);
     close(msg_fd);

     /* not totally positive that the message pointers will remain
	coherent...   but, maybe. :) */

     area->last++;
     
     return SUCCESS;

     
}

/* read a message. */

char *db_msg_read(int *size, MSG_Ref *lookup) {

     int msg_fd;
     char path[80];
     struct stat filestat;
     MSG_Area *area;
     char *body;

     if((area = area_by_name(lookup->name)) == NULL) {
	  return NULL;
     }

     sprintf(path, "%s/messages/%s/%d.msg", config->base_dir,
	     area->path, lookup->msg);
     
     msg_fd = open(path, O_RDONLY);
     if(msg_fd == -1) {
	  perror("read_message");
	  fprintf(stderr, "%s\n", path);
	  return NULL;
     }

     fstat(msg_fd, &filestat);

     body = (char *)malloc(filestat.st_size+1);
     
     (*size) = read(msg_fd, body, filestat.st_size);
     body[(*size)] = 0;
     close(msg_fd);

     return body;

}
     
int db_msg_clear(MSG_Ref *lookup) {

     char buffer[80];
     int ret;
     MSG_Area *area;

     if((area = area_by_name(lookup->name)) == NULL)
	  return FAILURE;

     sprintf(buffer, "%s/messages/%s/%d.msg", config->base_dir,
	     area->path, lookup->msg);

     if(lookup->msg == area->first)
	  area->first++;
     if(lookup->msg == area->last)
	  area->last--;

     if(unlink(buffer) == -1) {
	  perror("msg_clear");
	  fprintf(stderr, "%s\n", buffer);
	  return FAILURE;
     }


     return SUCCESS;

}

/* returns a pointer to the actual data of the area configuration
   based on the area name */

MSG_Area *area_by_name(char *name) {

     struct ll_areas *cur;

     cur = area_config;

     while((cur != NULL) && (strcasecmp(name, cur->data.area_name)))
	  cur = cur->next;

     return &(cur->data);

}

/* scans a message area for a user's messages.  Broken, as it only
   scans by handle */

int db_msg_scan_usr(int **msgs, int *len, char *handle, MSG_Ref *where) {

     int x;
     MSG_Head head;
     MSG_Area *area;
     int ret;

     if((area = area_by_name(where->name)) == NULL) 
	  return FAILURE;

     (*msgs) = (int *)malloc(sizeof(int));

     x = area->first;
     (*len) = 0;

     if(area->last == 0) {
	  (*msgs)[0] = 0;
	  ret = FAILURE;
     }
     else {
	  while(x <= area->last) {
	       where->msg = x;
	       db_msg_read_head(&head, where);
	       if(!strcasecmp(head.to, handle)) {
		    if(area->network_num != 0) {
			 /* compare destination addresses! */
		    }
		    else {
			 (*len)++;
			 (*msgs) = (int *)realloc((*msgs),
						  sizeof(int)*(*len));
			 
		    }
	       }
	       x++;
	  }
     }     

     if((*len) != 0)
	  return SUCCESS;
     else
	  return FAILURE;
}

/* opens the database which holds all the message pointers */

DBM *open_pointers(void) {

     char bleh[80];
     DBM *ret;

     strcpy(bleh,config->base_dir);
     strcat(bleh,"/db/pointers.db");

     ret = dbm_open(bleh, O_RDWR | O_CREAT, S_IREAD | S_IWRITE);

     if(ret == NULL) {
          printf("Couldn't open db: %s\n", bleh);
          exit(2);
     }

     return ret;

}

int db_point_read(int *point, char *keyst) {

     DBM *db;
     datum key;
     datum data;

     if((db = open_pointers()) == NULL) {
          return FAILURE;
     }

     key.dptr = keyst;
     key.dsize = strlen(keyst);
     data = dbm_fetch(db, key);

     if (data.dptr != NULL) 
	  memcpy(point, data.dptr, sizeof(int));
     else
	  (*point) = 0;

     dbm_close(db);
     
     (*point) =  abs((*point)); /* odd bug */
     return SUCCESS;

}

int db_point_write(int msg, char *keystr) {

     DBM *db;
     datum key;
     datum data;
     int ret;

     if((db = open_pointers()) == NULL) {
          return FAILURE;
     }

     key.dptr = keystr;
     key.dsize = strlen(keystr);

     data.dptr = (void *)&msg;
     data.dsize = sizeof(int);

     ret = dbm_store(db, key, data, DBM_REPLACE);

     dbm_close(db);
     return SUCCESS;

}

int db_point_clear(char *keystr) {

     DBM *db;
     datum key;
     int ret;

     if((db = open_pointers()) == NULL) {
          return -1;
     }
     key.dptr = keystr;
     key.dsize = strlen(keystr);

     ret = dbm_delete(db, key);

     dbm_close(db);

     return ret;

}

/* this function is rather misnamed, as all it does is shut the
   transit bit off. */

int db_msg_toggle_trans(MSG_Ref *lookup) {

     char filename[100];
     MSG_Head *head;
     MSG_Area *this_area;
     char *body;
     int size;
     int msg_fd;
     char buffer[80];
     

     this_area = area_by_name(lookup->name);
     if(this_area == NULL) {
	  return FAILURE;
     }

     if((body = db_msg_read(&size, lookup)) == NULL)
	  return FAILURE;

     /* hopefully, as the header is the first few bytes, this will
	work */
     head = (MSG_Head *)body;
     
     if(head->attribute & MSG_TRANSIT) {
	  head->attribute = head->attribute & ~MSG_TRANSIT;
     }     

     head->attribute |= MSG_SENT;
     
     sprintf(filename,
	     "%s/messages/%s/%d.msg",config->base_dir,this_area->path, 
	     lookup->msg);

     
     msg_fd = open(filename, O_WRONLY | O_TRUNC, S_IRUSR |
                   S_IWUSR | S_IRGRP | S_IROTH);

     if(msg_fd == -1) {
	  sprintf(buffer, "Couldn't clobber %s\n", filename);
	  db_log(255, buffer);
	  free(body);
	  return FAILURE;
     }
	  
     write(msg_fd, body, size);
     close(msg_fd);

     free(body);

     return 0;
}

int db_msg_read_head(MSG_Head *head, MSG_Ref *lookup) {

     static struct msg_hdr *ret;
     char path[100];
     int msg_fd;
     MSG_Area *area;

     if((area = area_by_name(lookup->name)) == NULL)
	  return FAILURE;
     

     sprintf(path, "%s/messages/%s/%d.msg", config->base_dir,
	     area->path, lookup->msg);

     msg_fd = open(path, O_RDONLY);
     if(msg_fd == -1) {
          return FAILURE;
     }
     
     if(read(msg_fd, head, sizeof(MSG_Head)) != sizeof(MSG_Head)) {
	  close(msg_fd);
	  return FAILURE;
     }
     
     close(msg_fd);

     return SUCCESS;

}

int db_msg_area(MSG_Area *info, char *name) {

     MSG_Area *area;

     if((area = area_by_name(name)) == NULL) 
	  return FAILURE;

     memcpy(info, area, sizeof(MSG_Area));
     return SUCCESS;
}

int db_msg_area_next(MSG_Area *info, MSG_Area *next) {

     
     struct ll_areas *cur;

     cur = area_config;

     while((cur != NULL) && (strcasecmp(info->area_name, cur->data.area_name)))
     	  cur = cur->next;
     
     /* no more areas */
     if(cur == NULL)
	  return FAILURE;

     memcpy(next, &(cur->next->data), sizeof(MSG_Area));
     return SUCCESS;

}

int db_msg_area_prev(MSG_Area *info, MSG_Area *next) {

     
     struct ll_areas *cur;
     struct ll_areas *prev = NULL;

     cur = area_config;

     while((cur != NULL) && (strcasecmp(info->area_name, cur->data.area_name))) {
	  prev = cur;
     	  cur = cur->next;
     }
     
     /* no previous area */
     if(prev == NULL)
	  return FAILURE;

     memcpy(next, &(prev->data), sizeof(MSG_Area));
     return SUCCESS;

}

int db_msg_net(MSG_Net *info, char *name) {

     struct ll_nets *cur;

     cur = net_config;

     /* walk to find this net... */
     while((cur != NULL) && (strcasecmp(name, cur->data.name)))
	  cur = cur->next;

     /* did we ever find it? */
     if(cur == NULL) 
	  return FAILURE;

     memcpy(info, &(cur->data), sizeof(MSG_Net));
     
     return SUCCESS;
}

