/* cli_misc.c -- catchall */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <curses.h>
#include <unistd.h>

#include <client.h>

#define DEBUG

extern BBS_Config *config;
extern int my_node;

BBS_Menu *read_menu(char *menuname){

     int db_sock;
     BBS_Menu *ret;
     DB_Req req;
     int size;
     int len, x;

     req.req = MENU_READ;
     req.datasize = 20;
     strcpy(req.key, config->db_key);
     req.node = my_node;

     if((db_sock = db_conn(&req)) == -1)
          return NULL;

     write(db_sock, menuname, 20);

     if((size = db_reply(db_sock)) == -1) {
	  close(db_sock);
          return NULL;
     }

     len = size/sizeof(BBS_Menu);
     ret = (BBS_Menu *)malloc(size);
     x = 0;

     while (x < len) {
	  read(db_sock, &(ret[x]), sizeof(BBS_Menu));
	  x++;
     }
     
     shutdown(db_sock,2);
     close(db_sock);
     return ret;
     
}

int log (char *fmt, ...) {
     
     int db_sock;
     char buffer[160];
     va_list argptr;
     DB_Req req;

     req.req = LOG_WRITE;
     req.datasize = 160;
     strcpy(req.key, config->db_key);
     req.node = my_node;

     if((db_sock = db_conn(&req)) == -1)
          return -1;
     
     va_start(argptr, fmt);
     vsprintf(buffer, fmt, argptr);
     va_end(argptr);

     write(db_sock, buffer, 160);

     if(db_reply(db_sock) == -1) {
	  close(db_sock);
          return -1;
     }

     close(db_sock);
     return 0;
     
}

int reload_db(void) {

     int db_sock;
     DB_Req req;
     int size;

     req.req = RELOAD;
     req.datasize = 0;
     strcpy(req.key, config->db_key);
     req.node = my_node;

     if((db_sock = db_conn(&req)) == -1)
          return -1;

     if(db_reply(db_sock) == -1) {
	  close(db_sock);
          return -1;
     }

     shutdown(db_sock, 2);
     close(db_sock);
     
     return 0;
}

