
#include <stdio.h>
#include <curses.h>
#include <unistd.h>
#include <stdlib.h>

#include <common.h>
#include <client.h>

extern BBS_Config *config;
extern int my_node;

tConnect *read_nl2k(tAddress *lookup, char *type) {

     tConnect *ret;
     int db_sock;
     DB_Req req;

     req.req = NODELIST_LOOKUP;
     req.datasize = sizeof(tAddress);
     strcpy(req.key, config->db_key);
     req.node = my_node;

     if((db_sock = db_conn(&req)) == -1)
          return NULL;

     write(db_sock, lookup, sizeof(tAddress));
     if(db_reply(db_sock) == -1) {
	  close(db_sock);
	  return NULL;
     }

     
     ret = (tConnect *)malloc(sizeof(tConnect)); 

     if(read(db_sock, ret, sizeof(tConnect)) < 
	sizeof(tConnect)) {
          shutdown(db_sock, 2);
          close(db_sock);
	  free(ret); 
          return NULL;
     }
     
     shutdown(db_sock, 2);
     close(db_sock);
     return ret;
}

/* tries all of the nl2k types looking for a given node.  If it never
   finds it, returns null.  Useful when we'd like the system name or
   something and we don't give a flying fuck about connecting to it. */

char *name_nl2k(tAddress *lookup) {

     static char *retc;
     tConnect *ret;

     /* try in order of hit likeliness.  I presume this order would
	look something like: phone, email, ftp, telnet, isdn, other */

     retc = (char *)malloc(40);

     if((ret = read_nl2k(lookup, "CP")) != NULL) 
	  strcpy(retc, ret->SiteName);
/*      else if ((ret = read_nl2k(lookup, "CE")) != NULL)
	  strcpy(retc, ret->Connect.SiteName);
     else if ((ret = read_nl2k(lookup, "CF")) != NULL) 
	  strcpy(retc, ret->Connect.SiteName);
     else if ((ret = read_nl2k(lookup, "CT")) != NULL) 
	  strcpy(retc, ret->Connect.SiteName);
     else if ((ret = read_nl2k(lookup, "CI")) != NULL) 
	  strcpy(retc, ret->Connect.SiteName);
     else if ((ret = read_nl2k(lookup, "OTH")) != NULL) 
     strcpy(retc, ret->Connect.SiteName); */
     else {
	  free(retc);
	  return NULL;
     }

     free(ret);
     return retc;

}
