
/* just contact the DB server, and tell it to do midnight maintenance. */

#include <stdio.h>
#include <curses.h>
#include <sys/time.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/socket.h>

#include <common.h>
#include <client.h>

BBS_Config *config;
BBS_Node *this_node;

int my_node = 0;

int main(int ac, char *av[]) {
     
     int db_sock, x;
     char buffer[80];
     DB_Req req;

/* get the system config. */

     config = (BBS_Config *)malloc(sizeof(BBS_Config));
     read_system_config();
     
     this_node = (BBS_Node *)malloc(sizeof(BBS_Node));
     this_node->current_user = (BBS_User *)read_user(config->sysop);

/* and inform the db server of it's orders. */


     req.req = MIDNIGHT;
     req.datasize = 0;
     strcpy(req.key, config->db_key);
     req.node = 0;

     if((db_sock = db_conn(&req)) == -1) {
          printf("Failed to send command to DB Server!\n");
	  exit(127);
     }
     close(db_sock);

     /* now tell all the nodes to fix their user time... */

     x = 1;
     while(x <= config->nodes) {

	  DB_Req req;
	  BBS_Node *node_dat;
	  if((node_dat = read_node(x)) != NULL) {
	       BBS_Inc msg;
	       msg.orig_node = 0;
	       msg.dest_node = x;
	       msg.start_time = time(NULL);
	       sprintf(msg.type, "1\n");

	       req.req = INC_SEND;
	       req.datasize = sizeof(BBS_Inc);
	       strcpy(req.key, config->db_key);
	       req.node = 0;

	       if((db_sock = db_conn(&req)) == -1) {
		    printf("Error sending to node %d\n");
		    x++;
		    continue;
	       }
		    
	       write(db_sock, &msg, sizeof(BBS_Inc));
	       if(db_reply(db_sock) == -1) {
    		    printf("Error sending to node %d\n");
		    close(db_sock);
		    x++;
		    continue;
	       }

	       shutdown(db_sock, 2);
	       close(db_sock);
	       
	  }
	  x++;
     }
     

     return 0;
	       
}
