
/* usertool.c -- contains interactive routines to help the sysop
   modify users. */

#include <stdio.h>
#include <unistd.h>
#include <curses.h>

#include "common.h"
#include "client.h"

BBS_Config *config;

void mod_user2(BBS_User *user);
int my_node = 0;

main(int ac, char *av[]) {
     
     char opt;
     BBS_User *cur_user;
     char handle[20];
     int x;

     config = (BBS_Config *)malloc(sizeof(BBS_Config));
     read_system_config();

     initscr();
     
     keypad(stdscr, TRUE);
     scrollok(stdscr, TRUE);
     immedok(stdscr, TRUE);

     while(opt != 'q'){
	  addstr("admin user configuration tool\n");
	  addstr("l)ist, a)dd, m)odify, h)andle, d)elete, q)uit: ");

	  opt = getch();
	  
	  addch('\n');

	  switch(opt) {
          case 'l': {
	       int len;
	       
               clear();

	       if((cur_user = read_userlist(&len)) == NULL) {
		    addstr("DB communication failure -- couldn't get list.\n");
		    break;
	       }

               x = 0;
               while (x < len) {
                    if (cur_user[x].handle[0] == '\0')
                         printw("%-4u** DELETED USER **\n",x+1);
                    else
                         printw("%-4u%s %s\n",x+1,cur_user[x].handle,
				cur_user[x].e_mail);
                    x++;
               }

               break;
	  }
	  case 'a':
	       cur_user = (BBS_User *)calloc(sizeof(BBS_User),1);
	       addstr("handle: ");
	       scanw("%s",cur_user->handle);

	       if((x = update_user(cur_user)) != 0) 
		    addstr("user add failed.. (?) \n");
	       else
		    addstr("user added.\n");
	       
	       free(cur_user);
	       break;
	       
	  case 'm':
	       addstr("handle: ");
	       scanw("%s", handle);
	       if((cur_user = read_user(handle)) == NULL) 
		    addstr("no such user (or file error?)\n");
	       else 
		    mod_user2(cur_user);
	       
	       free(cur_user);
	       break;

	  case 'd':
	       addstr("handle: ");
	       scanw("%s",handle);
	       if(clear_user(handle) != 0) {
		    addstr("deletion failed.\n");
		    break; }
	       else {
		    addstr("deletion succeded.\n");
		    break;
	       }

	  case 'h':
	       addstr("old handle: ");
	       getstr(handle);
	       addch('\n');
	       if((cur_user = read_user(handle)) == NULL) {
		    addstr("No such user.\n");
		    break;
	       }
	       addstr("new handle: ");
	       getstr(handle);
	       clear_user(cur_user->handle);
	       strcpy(cur_user->handle, handle);
	       update_user(cur_user);
	       addstr("Finished.\n");
	       free(cur_user);
	       break;

	       
	  case 'q':
	       /* quit key */
	       break;
	       
	  }
     }     
     
}

/* similar to the mod_user in the BBS, but more pimped out for the
   sysop. */

void mod_user2(BBS_User *cur_user) {

     char opt;
     int x;
     char pass[15];
     char salt[2];
     char *pass2;
     
     while(opt != 'q') {
	  clear();
	  addch('\n');
	  printw("handle: %s\n",cur_user->handle);   
	  printw("f)irst: %s\n",cur_user->first_name);   
	  printw("l)ast: %s\n",cur_user->last_name);   
	  printw("p)hone: %s\n",cur_user->phone);   
	  printw("e)mail: %s\n",cur_user->e_mail);
	  printw("last node: %d\n",cur_user->node);   
	  printw("r)emaining: %d\n",cur_user->remaining);   
	  printw("last login: %d\n",cur_user->last_login);   
	  printw("a)ccess: %d\n",cur_user->access);   
	  printw("c)rypt'd passwd: %s\n",cur_user->crypt_pass);   
	  printw("1)address #1: %s\n",cur_user->address[0]);
	  printw("2)address #2: %s\n",cur_user->address[1]);        
	  printw("c(i)ty: %s\n",cur_user->city);   
	  printw("s)tate: %s\n",cur_user->state);   
	  printw("z)ip: %s\n",cur_user->zip);   
	  printw("c(o)untry: %s\n",cur_user->country);
	  printw("9)color config\n");
	  printw("q)uit\n");
	  printw("\nmodify: ");

	  opt = getch();
	  
	  addch('\n');
	  
	  switch(opt) {
	  case 'e': 
	       addstr("e-mail address: ");
	       scanw("%s", cur_user->e_mail);
	       break;
	  case 'f':
	       addstr("first name: ");
	       scanw("%s",cur_user->first_name);
	       break;
	  case 'l':
	       addstr("last name: ");
	       scanw("%s",cur_user->last_name);
	       break;
	  case 'p':
	       addstr("phone #: ");
	       scanw("%s",cur_user->phone);
	       break;
	  case 'r':
	       addstr("remaining: ");
	       scanw("%d",&cur_user->remaining);
	       break;
	  case 'a':
	       addstr("access: ");
	       scanw("%u",&cur_user->access);
	       break;
	  case 'c':
	       addstr("passwd: ");
	       scanw("%s", pass);
               salt[0] = 65 + (getpid() % 26);
               salt[1] = 65 + (time(NULL) % 26);
               pass2 = (char *)crypt(pass, salt); /* why manually cast? */
	       memmove((char *)cur_user->crypt_pass, pass2, strlen(pass2));
	       break;
	  case '1':
	       addstr("addr line #1: ");
	       getstr(cur_user->address[0]);
	       break;
	  case '2': 
	       addstr("addr line #2: ");
	       getstr(cur_user->address[0]);
	       break;
	  case 'i':
	       addstr("city: ");
	       scanw("%s",cur_user->city);
	       break;
	  case 's':
	       addstr("state: ");
	       scanw("%s",cur_user->state);
	       break;
	  case 'z':
	       addstr("zip: ");
	       scanw("%s",cur_user->zip);
	       break;
	  case 'o':
	       addstr("country: ");
	       scanw("%s",cur_user->country);
	       break;
	  case 'q':  
	       return;
	       break;
/*	  case '9':
	       color_config(cur_user);
	       break;
*/
	  case '\n':
	       break;
	  default:
	       addstr("invalid selection\n");
	       break;
	  }

	  if((x = update_user(cur_user)) != 0) {
	       addstr("failed to update user db\n");
	  }
	  else {
	       addstr("user updated.\n");
	  }
     }
     
}



